From 2f793936f4b1beb73dbcc13fabc8f4febc24a60d Mon Sep 17 00:00:00 2001
From: bucoo <bucoo@sohu.com>
Date: Mon, 25 Jan 2021 21:43:30 +0800
Subject: [PATCH] support parallel union/distinct/aggregate using batch hashagg
 and sort

---
 src/backend/commands/explain.c                    |  20 +
 src/backend/executor/Makefile                     |   1 +
 src/backend/executor/execAmi.c                    |   5 +
 src/backend/executor/execParallel.c               |  17 +
 src/backend/executor/execProcnode.c               |  10 +
 src/backend/executor/nodeAgg.c                    | 637 +++++++++++++++++++---
 src/backend/executor/nodeBatchSort.c              | 554 +++++++++++++++++++
 src/backend/nodes/copyfuncs.c                     |  22 +
 src/backend/nodes/outfuncs.c                      |  18 +
 src/backend/nodes/readfuncs.c                     |  19 +
 src/backend/optimizer/path/costsize.c             | 110 +++-
 src/backend/optimizer/plan/createplan.c           |  61 ++-
 src/backend/optimizer/plan/planner.c              | 305 +++++++++++
 src/backend/optimizer/plan/setrefs.c              |   1 +
 src/backend/optimizer/plan/subselect.c            |   6 +
 src/backend/optimizer/prep/prepunion.c            |  81 ++-
 src/backend/optimizer/util/pathnode.c             |  39 ++
 src/backend/optimizer/util/tlist.c                |  21 +
 src/backend/postmaster/pgstat.c                   |   6 +
 src/backend/storage/lmgr/lwlock.c                 |   2 -
 src/backend/utils/misc/guc.c                      |  26 +
 src/backend/utils/sort/Makefile                   |   3 +-
 src/backend/utils/sort/batchstore.c               | 466 ++++++++++++++++
 src/backend/utils/sort/sharedtuplestore.c         | 163 +++++-
 src/backend/utils/sort/tuplesort.c                |  20 +
 src/include/executor/nodeAgg.h                    |   2 +
 src/include/executor/nodeBatchSort.h              |  19 +
 src/include/nodes/execnodes.h                     |  19 +
 src/include/nodes/nodes.h                         |   6 +-
 src/include/nodes/pathnodes.h                     |  11 +
 src/include/nodes/plannodes.h                     |  15 +
 src/include/optimizer/cost.h                      |   7 +
 src/include/optimizer/pathnode.h                  |   7 +
 src/include/optimizer/tlist.h                     |   1 +
 src/include/pgstat.h                              |   4 +-
 src/include/storage/lwlock.h                      |   1 -
 src/include/utils/batchstore.h                    |  38 ++
 src/include/utils/sharedtuplestore.h              |  14 +
 src/include/utils/tuplesort.h                     |   1 +
 src/test/regress/expected/groupingsets.out        |  65 +++
 src/test/regress/expected/partition_aggregate.out | 138 +++++
 src/test/regress/expected/select_distinct.out     |  77 +++
 src/test/regress/expected/select_parallel.out     |  86 +++
 src/test/regress/expected/union.out               |  85 +++
 src/test/regress/sql/groupingsets.sql             |  10 +
 src/test/regress/sql/partition_aggregate.sql      |  45 ++
 src/test/regress/sql/select_distinct.sql          |  23 +
 src/test/regress/sql/select_parallel.sql          |  32 ++
 src/test/regress/sql/union.sql                    |  28 +
 49 files changed, 3223 insertions(+), 124 deletions(-)
 create mode 100644 src/backend/executor/nodeBatchSort.c
 create mode 100644 src/backend/utils/sort/batchstore.c
 create mode 100644 src/include/executor/nodeBatchSort.h
 create mode 100644 src/include/utils/batchstore.h

diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index 5d7eb3574c..cd38289fbb 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -1283,6 +1283,9 @@ ExplainNode(PlanState *planstate, List *ancestors,
 		case T_Sort:
 			pname = sname = "Sort";
 			break;
+		case T_BatchSort:
+			pname = sname = "BatchSort";
+			break;
 		case T_IncrementalSort:
 			pname = sname = "Incremental Sort";
 			break;
@@ -1312,6 +1315,10 @@ ExplainNode(PlanState *planstate, List *ancestors,
 						pname = "MixedAggregate";
 						strategy = "Mixed";
 						break;
+					case AGG_BATCH_HASH:
+						pname = "BatchHashAggregate";
+						strategy = "BatchHashed";
+						break;
 					default:
 						pname = "Aggregate ???";
 						strategy = "???";
@@ -1946,6 +1953,18 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			show_sort_keys(castNode(SortState, planstate), ancestors, es);
 			show_sort_info(castNode(SortState, planstate), es);
 			break;
+		case T_BatchSort:
+			{
+				BatchSort *bsort = (BatchSort*)plan;
+				show_sort_group_keys(planstate, "Sort Key",
+									 bsort->sort.numCols, 0, bsort->sort.sortColIdx,
+									 bsort->sort.sortOperators, bsort->sort.collations,
+									 bsort->sort.nullsFirst,
+									 ancestors, es);
+				if (es->verbose)
+					ExplainPropertyInteger("batches", NULL, bsort->numBatches, es);
+			}
+			break;
 		case T_IncrementalSort:
 			show_incremental_sort_keys(castNode(IncrementalSortState, planstate),
 									   ancestors, es);
@@ -3054,6 +3073,7 @@ show_hashagg_info(AggState *aggstate, ExplainState *es)
 	int64		memPeakKb = (aggstate->hash_mem_peak + 1023) / 1024;
 
 	if (agg->aggstrategy != AGG_HASHED &&
+		agg->aggstrategy != AGG_BATCH_HASH &&
 		agg->aggstrategy != AGG_MIXED)
 		return;
 
diff --git a/src/backend/executor/Makefile b/src/backend/executor/Makefile
index f990c6473a..a4855a8881 100644
--- a/src/backend/executor/Makefile
+++ b/src/backend/executor/Makefile
@@ -33,6 +33,7 @@ OBJS = \
 	instrument.o \
 	nodeAgg.o \
 	nodeAppend.o \
+	nodeBatchSort.o \
 	nodeBitmapAnd.o \
 	nodeBitmapHeapscan.o \
 	nodeBitmapIndexscan.o \
diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
index 23bdb53cd1..ecbcc09b51 100644
--- a/src/backend/executor/execAmi.c
+++ b/src/backend/executor/execAmi.c
@@ -17,6 +17,7 @@
 #include "executor/execdebug.h"
 #include "executor/nodeAgg.h"
 #include "executor/nodeAppend.h"
+#include "executor/nodeBatchSort.h"
 #include "executor/nodeBitmapAnd.h"
 #include "executor/nodeBitmapHeapscan.h"
 #include "executor/nodeBitmapIndexscan.h"
@@ -253,6 +254,10 @@ ExecReScan(PlanState *node)
 			ExecReScanSort((SortState *) node);
 			break;
 
+		case T_BatchSortState:
+			ExecReScanBatchSort((BatchSortState *)node);
+			break;
+
 		case T_IncrementalSortState:
 			ExecReScanIncrementalSort((IncrementalSortState *) node);
 			break;
diff --git a/src/backend/executor/execParallel.c b/src/backend/executor/execParallel.c
index c95d5170e4..98937302c2 100644
--- a/src/backend/executor/execParallel.c
+++ b/src/backend/executor/execParallel.c
@@ -27,6 +27,7 @@
 #include "executor/executor.h"
 #include "executor/nodeAgg.h"
 #include "executor/nodeAppend.h"
+#include "executor/nodeBatchSort.h"
 #include "executor/nodeBitmapHeapscan.h"
 #include "executor/nodeCustom.h"
 #include "executor/nodeForeignscan.h"
@@ -284,6 +285,10 @@ ExecParallelEstimate(PlanState *planstate, ExecParallelEstimateContext *e)
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
 			ExecSortEstimate((SortState *) planstate, e->pcxt);
 			break;
+		case T_BatchSortState:
+			if (planstate->plan->parallel_aware)
+				ExecBatchSortEstimate((BatchSortState*)planstate, e->pcxt);
+			break;
 		case T_IncrementalSortState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
 			ExecIncrementalSortEstimate((IncrementalSortState *) planstate, e->pcxt);
@@ -504,6 +509,10 @@ ExecParallelInitializeDSM(PlanState *planstate,
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
 			ExecSortInitializeDSM((SortState *) planstate, d->pcxt);
 			break;
+		case T_BatchSortState:
+			if (planstate->plan->parallel_aware)
+				ExecBatchSortInitializeDSM((BatchSortState*)planstate, d->pcxt);
+			break;
 		case T_IncrementalSortState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
 			ExecIncrementalSortInitializeDSM((IncrementalSortState *) planstate, d->pcxt);
@@ -990,6 +999,10 @@ ExecParallelReInitializeDSM(PlanState *planstate,
 		case T_IncrementalSortState:
 			/* these nodes have DSM state, but no reinitialization is required */
 			break;
+		case T_BatchSortState:
+			if (planstate->plan->parallel_aware)
+				ExecBatchSortReInitializeDSM((BatchSortState*)planstate, pcxt);
+			break;
 
 		default:
 			break;
@@ -1340,6 +1353,10 @@ ExecParallelInitializeWorker(PlanState *planstate, ParallelWorkerContext *pwcxt)
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
 			ExecSortInitializeWorker((SortState *) planstate, pwcxt);
 			break;
+		case T_BatchSortState:
+			if (planstate->plan->parallel_aware)
+				ExecBatchSortInitializeWorker((BatchSortState*)planstate, pwcxt);
+			break;
 		case T_IncrementalSortState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
 			ExecIncrementalSortInitializeWorker((IncrementalSortState *) planstate,
diff --git a/src/backend/executor/execProcnode.c b/src/backend/executor/execProcnode.c
index 414df50a05..d51750e4fb 100644
--- a/src/backend/executor/execProcnode.c
+++ b/src/backend/executor/execProcnode.c
@@ -75,6 +75,7 @@
 #include "executor/executor.h"
 #include "executor/nodeAgg.h"
 #include "executor/nodeAppend.h"
+#include "executor/nodeBatchSort.h"
 #include "executor/nodeBitmapAnd.h"
 #include "executor/nodeBitmapHeapscan.h"
 #include "executor/nodeBitmapIndexscan.h"
@@ -314,6 +315,11 @@ ExecInitNode(Plan *node, EState *estate, int eflags)
 												estate, eflags);
 			break;
 
+		case T_BatchSort:
+			result = (PlanState *) ExecInitBatchSort((BatchSort *) node,
+													 estate, eflags);
+			break;
+
 		case T_IncrementalSort:
 			result = (PlanState *) ExecInitIncrementalSort((IncrementalSort *) node,
 														   estate, eflags);
@@ -699,6 +705,10 @@ ExecEndNode(PlanState *node)
 			ExecEndSort((SortState *) node);
 			break;
 
+		case T_BatchSortState:
+			ExecEndBatchSort((BatchSortState *) node);
+			break;
+
 		case T_IncrementalSortState:
 			ExecEndIncrementalSort((IncrementalSortState *) node);
 			break;
